<?php
namespace Jobs\Controller;

class CJobObject
{
    public $uuid        =''; //job uuid
    public $topic       =''; //job 队列名
    public $jobClass    =''; //job 执行类
    public $jobMethod   =''; //job 执行方法
    public $jobParams   =[]; //job参数
    public $jobExtras   =[]; //附件信息，delay/expiration/priority等

    public function __construct( $topic, $jobClass, $jobMethod, array $jobParams=[], array $jobExtras=[])
    {
        $this->uuid       =uniqid($topic) . '.' . microtime(true);
        $this->topic      =$topic;
        $this->jobClass   =$jobClass;
        $this->jobMethod  =$jobMethod;
        $this->jobParams  =$jobParams;
        $this->jobExtras  =$jobExtras;
    }
}