<?php
/**
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/11/23
 * Time: 9:22
 */

namespace Jobs\Dao\Order;

use Jobs\Dao\BaseDao;

class DOrderIndex extends BaseDao
{
    public function __construct($serviceDB = 'default')
    {
        $this->_table = 'order_index';
        $this->_primary = 'id';
        $this->_fields = [
            "id", //int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
            "orderId", //int(11) NOT NULL COMMENT '订单id',
            "userCenterId", //int(11) NOT NULL COMMENT 'userCenterId',
            "shopId", //int(11) NOT NULL COMMENT 'shopId',
            "createTime", //int(10) DEFAULT NULL COMMENT '创建时间',
            "updateTime", //int(10) DEFAULT NULL COMMENT '更新时间',
            "deleteStatus", //tinyint(3) DEFAULT '5' COMMENT '删除状态',
            "auditStatus", //tinyint(3) DEFAULT NULL COMMENT '审核状态',
            "salesManId", //int(10) DEFAULT NULL COMMENT '业务员id',
            "payStatus", //tinyint(3) DEFAULT '4' COMMENT '支付状态  默认4 未支付 5已支付',
            "orderStatus", //tinyint(3) DEFAULT NULL COMMENT '订单状态 默认 2待支付 3代发货 4待收货 5已完成 6已关闭',
            "outStatus",
            "returnStatus",
            "deliveryType", //tinyint(3) DEFAULT NULL COMMENT '配送方式 1商品配送 2上门自提',
            "payType",//支付方式
            "customerId",//客户id
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
        ];
        $this->_update_autofill = [
        ];

        parent::__construct($serviceDB);
    }
}