<?php
/**
 * Created by PhpStorm.
 * User: XiaoMing
 * Date: 2019/12/23
 * Time: 16:21
 */

namespace Jobs\Model\MTopic\Market;

use Jobs\Dao\DCoupon;
use Jobs\Dao\DUserCoupon;
use Mall\Framework\Core\StatusCode;

class MRegisterCoupon
{
    use MCoupon;

    private $objDUserCoupon;

    private $objDCoupon;

    private $onlineEnterpriseId;

    /**
     * MUserCoupon constructor.
     * @throws \Exception
     */
    public function __construct()
    {
        echo '注册发放优惠券:'.date('Y-d-d H:i:s').': ';
        $this->objDUserCoupon = new DUserCoupon();
        $this->objDCoupon = new DCoupon();
        $this->objDUserCoupon->setSearchIndex('user_coupon_search')->setType('user_coupon');;
    }

    /**
     * @param $params
     * @throws \Exception
     */
    public function push($params)
    {
        $this->onlineEnterpriseId = $params['enterpriseId'];
        // 计算分表
        $this->objDUserCoupon->setTable($this->objDUserCoupon->get_Table() . '_' . $params['enterpriseId']);
        $this->objDCoupon->setTable($this->objDCoupon->get_Table() . '_' . $params['enterpriseId']);
        $coupon = self::selectCoupon($this->objDCoupon,['grantType'=>StatusCode::$grantType['register']]);
        $checkCoupon = self::checkCoupon($this->objDUserCoupon,$coupon,$params);
        self::add($this->objDUserCoupon,$checkCoupon,$params);
        self::receiveNumIncr($this->objDCoupon,$checkCoupon,$params);
    }
}