<?php
/**
 * Created by PhpStorm.
 * User: wxj
 * Date: 2019/11/28
 * Time: 10:20
 */
namespace Jobs\Dao;

use Jobs\Dao\BaseDao;

class DLoginLog extends BaseDao
{
    public function __construct($serviceDB = 'log')
    {
        $this->_table = 'login_log_2019_12';
        $this->_primary = 'id';
        $this->_fields = [
              'userCenterId',//int(11) DEFAULT NULL COMMENT '会员id',
              'enterpriseId',//int(11) DEFAULT NULL COMMENT '企业id',
              'mobile',//varchar(255) DEFAULT NULL COMMENT '注册手机号码',
              'createTime',//varchar(20) DEFAULT NULL COMMENT '操作时间',
              'source',//varchar(50) DEFAULT NULL COMMENT '来源'
              'actionType',//varchar(255) DEFAULT NULL COMMENT '操作类型',
              'operationData',//json DEFAULT NULL COMMENT '提交数据',
        ];
        $this->_readonly = ['id'];
        $this->_create_autofill = [
        ];
        $this->_update_autofill = [
        ];

        parent::__construct($serviceDB);
    }
}