<?php
/**
 * 企业
 * Created by PhpStorm.
 * User: 小威
 * Date: 2020/06/30
 * Time: 18:41
 */

namespace Jobs\Model\MTopic\Enterprise;


use Mall\Framework\Core\ErrorCode;
use Mall\Framework\Core\ResultWrapper;
use Mall\Framework\Core\StatusCode;

class MEnterprise
{
    private $enterpriseId;

    private $userCenterId;

    private $objDMessage;

    /**
     * MGrantCoupon constructor.
     * @throws \Exception
     */
    public function __construct()
    {
        echo '企业创建自动创建数据:' . date('Y-d-d H:i:s') . ':' . PHP_EOL;
    }

    /**
     * 自动创建
     * @param $params
     * @return bool
     * @throws \Exception
     */
    public function autoCreate($params)
    {
        echo '开始执行自动创建队列方法**************************************************************************************************************************';
        var_dump($params);
        $project_domain = $params['data']['PROJECT_DOMAIN'];
        unset($params['data']['PROJECT_DOMAIN']);
        if(empty($params['data']['enterpriseId'])){
            echo '企业id参数错误'.PHP_EOL;
            return false;
        }
        if(empty($params['data']['userCenterId'])){
            echo '用户id参数错误'.PHP_EOL;
            return false;
        }
        if(empty($params['data']['Authorization'])){
            echo 'Authorization参数错误'.PHP_EOL;
            return false;
        }

        switch ($project_domain){
            case 'api':
                $ip = URL_API.'/Enterprise/UserEnterprise/autoCreateData';
                break;
            default:
                $ip = DEV_URL_API.'/Enterprise/UserEnterprise/autoCreateData';
        }

        $postData = [
            'enterpriseId' => $params['data']['enterpriseId'],
            'userCenterId' => $params['data']['userCenterId']
        ];
        $post = json_encode($postData);
        $curl_option = [
            CURLOPT_HTTPHEADER => [
                'Content-Type:text/plain',
                'Authorization:'.$params['data']['Authorization'],
            ],
        ];
        $result = request($ip, $post, 40, false,$curl_option);
        print_r($result);
        echo '成功' . PHP_EOL;
        return true;
    }


}