#暂时记录些必要关键事件

1. 程序默认保留关键字，既所有的类名和文件夹都不得出现以下关键字

    类名相关：
    ```
    Service Smarty Backend Static

    ```
    PS: 项目模块名称全部保留，不得为类名

    参数相关
    ```
    a c m
    ```

2. 开发组建等其他的应用时请遵守核心思想开发规范

3. 目录权限

    ```
    项目目录下的Storage 777
    ```

4. 项目下的Config 定义

    ```
    每个项目应该都有.ENV.php(统一配置常量), 所有的Config目录下的config的值应都来自与.ENV.php的常量
    ```

5. composer使用

    ```
    1. 安装请百度
    2. 在框架根目录下敲入命令 composer install
    3. 根据提示选择行敲入 composer update
    ```
6. Git提交格式

    ```
    规范格式：
        * 这里是提交修改代码的说明
        + 这里是提交添加功能的说明
        正确格式应为
        修饰符+空格+文字说明
    ```